Qt Reference Documentation

- Qt 4.8
- ALL VERSIONS

- A
- A
- A
- Print

# Configuration Options for Qt

This page gives a brief description of the different options available when building Qt using the `configure` script or `configure.exe` binary. To build Qt using the default options, just call configure from the command line as shown below.

When building on Linux, Mac OS X and Unix platforms:

`./configure`

On Windows, run the corresponding executable:

`.\configure.exe`

If you would like to customize your build, please use the options listed in the following tables. To see the full list of options, invoke the configure tool with the `-help` command line option.

### Cross platform options:

Option | Description | Note
--- | --- | ---
`-buildkey` <key> | Build the Qt library and plugins using the specified |
`<key>` | When the library loads plugins, it will only load those that have a matching <key>. |
`-release` | Compile and link Qt with debugging turned off. |
`-debug` | Compile and link Qt with debugging turned on. | Default value.
`-debug-and-release` | Compile and link two Qt libraries, with and without debugging turned on. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-opensource` | Compile and link the Open-Source Edition of Qt. |
`-commercial` | Compile and link the Commercial Edition of Qt. |
`-developer-build` | Compile and link Qt with Qt developer options including auto-tests exporting) |
`-shared` | Create and use shared Qt libraries. | Default value.
`-static` | Create and use static Qt libraries. |
`-ltcg` | Use Link Time Code Generation. | Apply to release builds only.
`-no-ltcg` | Do not use Link Time Code Generation. | Default value.
`-no-fast` | Configure Qt normally by generating Makefiles for all project files. | Default value.
`-fast` | Configure Qt quickly by generating Makefiles only for library and subdirectory targets. | All other Makefiles are created as wrappers which will in turn run qmake.
`-no-exceptions` | Disable exceptions on platforms that support it. |
`-exceptions` | Enable exceptions on platforms that support it. | Default value.
`-no-accessibility` | Do not compile Windows Active Accessibility support. |
`-accessibility` | Compile Windows Active Accessibility support. | Default value.
`-no-stl` | Do not compile STL support. |
`-stl` | Compile STL support. | Default value.
`-no-sql-<driver>` | Disable SQL <driver> entirely, by default none are turned on. |
`-qt-sql-<driver>` | Enable a SQL <driver> in the Qt Library. |
`-plugin-sql-<driver>` | Enable SQL <driver> as a plugin to be linked to at run time. | Available values for <driver>: mysql, psql, oci, odbc, tds, db2, sqlite, sqlite2, ibase. Drivers marked with a '+' during configure have been detected as available on this system.
`-system-sqlite` | Use sqlite from the operating system. |
`-no-qt3support` | Disables the Qt 3 support functionality. |
`-no-opengl` | Disables OpenGL functionality |
`-opengl <api>` | Enable OpenGL support with specified API version. | Available values for <api>: desktop - Enable support for Desktop OpenGL (Default), es1 - Enable support for OpenGL ES Common Profile, es2 - Enable support for OpenGL ES 2.0.
`-no-openvg` | Disables OpenVG functionality | Default value.
`-openvg` | Enables OpenVG functionality | Requires EGL support, typically supplied by an OpenGL or other graphics implementation.
`-platform <spec>` | The operating system and compiler you are building on. | The default value is %QMAKESPEC%.
`-xplatform <spec>` | The operating system and compiler you are cross compiling for. | See the README file for a list of supported operating systems and compilers.
`-qtnamespace <namespace>` | Wraps all Qt library code in 'namespace name {..} |
`-qtlibinfix <infix>` | Renames all Qt* libs to Qt*<infix> |
`-D <define>` | Add an explicit define to the preprocessor. |
`-I <includepath>` | Add an explicit include path. |
`-L <librarypath>` | Add an explicit library path. |
`-l <libraryname>` | Add an explicit library name, residing in a librarypath. |
`-graphicssystem <sys>` | Specify which graphics system should be used. | Available values for <sys>: * raster - Software rasterizer, opengl - Using OpenGL acceleration, experimental!, openvg - Using OpenVG acceleration, experimental!
`-help, -h, -?` | Display this information. |

### Third Party Libraries

Option | Description | Note
--- | --- | ---
`-qt-zlib` | Use the zlib bundled with Qt. |
`-system-zlib` | Use zlib from the operating system. | See http://www.gzip.org/zlib
`-no-gif` | Do not compile GIF reading support. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-libpng` | Do not compile PNG support. |
`-qt-libpng` | Use the libpng bundled with Qt. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-system-libpng` | Use libpng from the operating system. | See http://www.libpng.org/pub/png
`-no-libmng` | Do not compile MNG support. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-qt-libmng` | Use the libmng bundled with Qt. |
`-system-libmng` | Use libmng from the operating system. | See http://www.libmng.com
`-no-libtiff` | Do not compile TIFF support. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-qt-libtiff` | Use the libtiff bundled with Qt. |
`-system-libtiff` | Use libtiff from the operating system. | See http://www.libtiff.org
`-no-libjpeg` | Do not compile JPEG support. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-qt-libjpeg` | Use the libjpeg bundled with Qt. |
`-system-libjpeg` | Use libjpeg from the operating system. | See http://www.ijg.org. This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.

### Qt for Windows only:

Option | Description | Note
--- | --- | ---
`-no-dsp` | Do not generate VC++ .dsp files. |
`-dsp` | Generate VC++ .dsp files, only if spec "win32-msvc". | Default value.
`-no-vcproj` | Do not generate VC++ .vcproj files. |
`-vcproj` | Generate VC++ .vcproj files, only if platform "win32-msvc.net". | Default value.
`-no-incredibuild-xge` | Do not add IncrediBuild XGE distribution commands to custom build steps. |

`-incredibuild-xge`

Add IncrediBuild XGE distribution commands to custom build steps. This will distribute MOC and UIC steps, and other custom buildsteps which are added to the INCREDIBUILD_XGE variable.

The IncrediBuild distribution commands are only added to Visual Studio projects. This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.

`-no-plugin-manifests` | Do not embed manifests in plugins. |
`-plugin-manifests` | Embed manifests in plugins. | Default value.
`-no-qmake` | Do not compile qmake. |
`-qmake` | Compile qmake. | Default value
`-dont-process` | Do not generate Makefiles/Project files. This will override -no-fast if specified. |
`-process` | Generate Makefiles/Project files. | Default value.
`-no-rtti` | Do not compile runtime type information. |
`-rtti` | Compile runtime type information. | Default value.
`-no-mmx` | Do not compile with use of MMX instructions |
`-mmx` | Compile with use of MMX instructions | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-3dnow` | Do not compile with use of 3DNOW instructions |
`-3dnow` | Compile with use of 3DNOW instructions | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-sse` | Do not compile with use of SSE instructions |
`-sse` | Compile with use of SSE instructions | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-sse2` | Do not compile with use of SSE2 instructions |
`-sse2` | Compile with use of SSE2 instructions | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-openssl` | Do not compile in OpenSSL support |
`-openssl` | Compile in run-time OpenSSL support | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-openssl-linked` | Compile in linked OpenSSL support |
`-no-dbus` | Do not compile in D-Bus support |
`-dbus` | Compile in D-Bus support and load libdbus-1 dynamically. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-dbus-linked` | Compile in D-Bus support and link to libdbus-1 |
`-no-phonon` | Do not compile in the Phonon module |
`-phonon` | Compile the Phonon module. | Phonon is built if a decent C++ compiler is used. This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-phonon-backend` | Do not compile the platform-specific Phonon backend-plugin |
`-phonon-backend` | Compile in the platform-specific Phonon backend-plugin | Default value.
`-no-multimedia` | Do not compile the multimedia module |
`-multimedia` | Compile in multimedia module | Default value.
`-no-audio-backend` | Do not compile in the platform audio backend into QtMultimedia |
`-audio-backend` | Compile in the platform audio backend into QtMultimedia | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-webkit` | Do not compile in the WebKit module |
`-webkit` | Compile in the WebKit module | WebKit is built if a decent C++ compiler is used. This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-webkit-debug` | Compile in the WebKit module with debug symbols. |
`-no-script` | Do not build the QtScript module. |
`-script` | Build the QtScript module. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-scripttools` | Do not build the QtScriptTools module. |
`-scripttools` | Build the QtScriptTools module. | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-declarative` | Do not build the declarative module |
`-declarative` | Build the declarative module | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-declarative-debug` | Do not build the declarative debugging support |
`-declarative-debug` | Build the declarative debugging support | Default value.
`-arch <arch>` | Specify an architecture. | Available values for <arch>: * windows, windowsce, symbian, boundschecker, generic.
`-no-style-<style>` | Disable <style> entirely. |
`-qt-style-<style>` | Enable <style> in the Qt Library. | Available styles: * windows, + windowsxp, + windowsvista, * plastique, * cleanlooks, * motif, * cde, windowsce, windowsmobile, s60
`-no-native-gestures` | Do not use native gestures on Windows 7. |
`-native-gestures` | Use native gestures on Windows 7. | Default value.
`-no-mp` | Do not use multiple processors for compiling with MSVC | Default value.
`-mp` | Use multiple processors for compiling with MSVC (-MP) |
`-loadconfig <config>` | Run configure with the parameters from file configure_<config>.cache. |
`-saveconfig <config>` | Run configure and save the parameters in file configure_<config>.cache. |
`-redo` | Run configure with the same parameters as last time. |

### Qt for Windows CE only:

Option | Description | Note
--- | --- | ---
`-no-iwmmxt` | Do not compile with use of IWMMXT instructions |
`-iwmmxt` | Do compile with use of IWMMXT instructions. | This is for Qt for Windows CE on Arm only. This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-no-crt` | Do not add the C runtime to default deployment rules. | Default value.
`-qt-crt` | Qt identifies C runtime during project generation |
`-crt <path>` | Specify path to C runtime used for project generation. |
`-no-cetest` | Do not compile Windows CE remote test application |
`-cetest` | Compile Windows CE remote test application | This option denotes a default value and needs to be evaluated. If the evaluation succeeds, the feature is included.
`-signature <file>` | Use file for signing the target project |
`-phonon-wince-ds9` | Enable Phonon Direct Show 9 backend for Windows CE | Default value

### Qt for Symbian OS only:

Option | Description | Note
--- | --- | ---
`-no-freetype` | Do not compile in Freetype2 support. | Default value.
`-qt-freetype` | Use the libfreetype bundled with Qt. |
`-fpu <flags>` | VFP type on ARM, supported options: softvfp(default) |vfpv2 | softvfp+vfpv2 |
`-no-s60` | Do not compile in S60 support. |
`-s60` | Compile with support for the S60 UI Framework | Default value.
`-no-usedeffiles` | Disable the usage of DEF files. |
`-usedeffiles` | Enable the usage of DEF files. |